"use strict";

var _toArray = function (arr) {
  return Array.isArray(arr) ? arr : Array.from(arr);
};

exports.denodeify = denodeify;
exports.defer = defer;
function denodeify(fn) {
  return function () {
    var args = [];

    for (var _key = 0; _key < arguments.length; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve, reject) {
      fn.apply(undefined, _toArray(args).concat([function (err) {
        var args = [];

        for (var _key2 = 1; _key2 < arguments.length; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        if (err) {
          reject(err);
          return;
        }

        resolve.apply(undefined, _toArray(args));
      }]));
    });
  };
}

function defer() {
  var ret = {};

  ret.promise = new Promise(function (resolve, reject) {
    ret.resolve = resolve;
    ret.reject = reject;
  });

  return ret;
}